#include "svg.h"
#include <iostream>
#include <string>
#include <vector>

void svg_begin(double width, double height) {
    std::cout << "<?xml version='1.0' encoding='UTF-8'?>\n";
    std::cout << "<svg ";
    std::cout << "width='" << width << "' ";
    std::cout << "height='" << height << "' ";
    std::cout << "viewBox='0 0 " << width << " " << height << "' ";
    std::cout << "xmlns='http://www.w3.org/2000/svg'>\n";
}

void svg_end() {
    std::cout << "</svg>\n";
}

void svg_rect(double x, double y, double width, double height, std::string stroke, std::string fill) {
    std::cout << "<rect x='" << x<< "' y='" << y << "' width='" << width << "' height='" << height << "' stroke='" << stroke << "' fill='" << fill << "' />\n";
}

void svg_text(double left, double baseline, std::string text) {
    std::cout << "<text x='" << left << "' y='" << baseline << "'>" << text << "</text>\n";
}
void show_histogram_svg(const std::vector<size_t>& bins) {
    const auto IMAGE_WIDTH = 400;
    const auto IMAGE_HEIGHT = 300;
    const auto TEXT_LEFT = 20;
    const auto TEXT_BASELINE = 20;
    const auto TEXT_WIDTH = 50;
    const auto BIN_HEIGHT = 30;
    const auto BLOCK_WIDTH = 10;

    svg_begin(IMAGE_WIDTH, IMAGE_HEIGHT);
    for (size_t i = 0; i < bins.size(); ++i) {
        const double bin_width = BLOCK_WIDTH * bins[i];
        const double top = i * BIN_HEIGHT;
        svg_text(TEXT_LEFT, top + TEXT_BASELINE, std::to_string(bins[i]));
        svg_rect(TEXT_WIDTH, top, bin_width, BIN_HEIGHT, "black", "#aaffaa");
    }
    svg_end();
}



